package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkCenterPartRelationService;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCenterPartRelation;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/7/3 19:10
 * @Modify:
 **/
@Service
@Slf4j
public class MesWorkCenterPartRelationService extends BaseMesService<MesWorkCenterPartRelation>  implements IMesWorkCenterPartRelationService {

    @Override
    protected void onInsertBean(MesWorkCenterPartRelation item) {
        DdlPackBean partRelationPackBean = DdlPackBean.getDdlPackBean(AuthUtil.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getWorkCenterCode(), "workCenterCode", partRelationPackBean);
        DdlPreparedPack.getStringEqualPack(item.getPartNo(), "partNo", partRelationPackBean);
        boolean flg = baseRDao.isExitByHql(partRelationPackBean);
        if (flg) {
            throw ImppExceptionBuilder.newInstance()
                    .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
                    .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
                    .setErrorDetail("产线【%s】与零件【%s】关系已存在,请勿重复添加!",item.getWorkCenterCode(),item.getPartNo())
                    .build();
        }
    }
}
